// coding: utf-8
/*! Created by: Udo Schmal | https://www.gocher.me/ */
(function () {
  'use strict';
  var localLinks = document.querySelectorAll("[href^='#']");
  function Accordion(accordion) {
    let multiselect = accordion.dataset.multiselect === 'true';
    let allclosed =  accordion.dataset.allclosed === 'true';
    let current = null;
    let sheets = accordion.children;
    let hash = window.location.hash;
    let anchor = null;
    if (hash) {
      let id = hash.substr(1);
      anchor = document.getElementById(id);
    }
    function toggle(event) {
      let sheet = this.parentNode;
      if (multiselect) {
        sheet.classList.toggle("active");
      } else {
        if (current !== sheet) {
          if (current) {
            current.classList.remove("active");
          }
          current = sheet;
          sheet.classList.add("active");
        } else if (allclosed) {
          if (current) {
            current.classList.remove("active");
          }
          current = null;
        }
      }
    }
    for (let i = 0; i < sheets.length; i++) {
      if (anchor && sheets[i].contains(anchor)) {
        if (!multiselect && current) {
          current.classList.remove("active");
        }
        sheets[i].classList.add("active");
        current = sheets[i];
      } else if (!multiselect && sheets[i].classList.contains("active")) {
        if (current) {
          sheets[i].classList.remove("active");
        } else {
          current = sheets[i];
        }
      }
      let header = sheets[i].querySelector('.sheet-header');
      header.setAttribute('tabindex', '0');
      header.setAttribute('role', 'button');
      header.addEventListener('click', toggle);
      let ids = sheets[i].querySelectorAll("[id]");
      for (let iId = 0; iId < ids.length; iId++) {
        for (let ilocalLinks = 0; ilocalLinks < localLinks.length; ilocalLinks++) {
          if (localLinks[ilocalLinks].href.split('#')[1] == ids[iId].id) {
            localLinks[ilocalLinks].addEventListener('click', function (event) {
              header.click();
            });
          }
        }
      }
    }
    if (!multiselect && !allclosed && !current && (sheets.length > 0)) {
      sheets[0].classList.add("active");
      current = sheets[0];
    }
  }

  var accordionList = document.querySelectorAll("ul.accordion");
  if (accordionList.length > 0) {
    for (var i=0; i<accordionList.length; i++) {
      if (accordionList[i].children && accordionList[i].children.length > 0) {
        new Accordion(accordionList[i]);
      }
    }
    // accessibility: handle tabindex enter keydown event
    document.addEventListener('keydown',  function(event) {
      if (event.key === "Enter") {
        if (event.target.parentNode && event.target.parentNode.classList.contains('accordion')) {
          event.target.click();
        }
      }
    });
  }
})();
